/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Abstrakt.AbstrStrom.DoSirky;

import Abstrakt.AbstrStrom.IProhlidka;
import Abstrakt.ADL.AbstrDoubleList;
import Abstrakt.ADL.IAbstrDoubleList;

/**
 * Prohlídka do šířky, využívající frontu
 * @author Administrator
 */
public class Prohlidka<objType> implements IProhlidka<objType> {

    private IAbstrDoubleList<objType> iAbstrDoubleList = new AbstrDoubleList<objType>() {
    };

    /**
     * Vrací datový kontejner ukládaných dat
     * @return datový kontejner
     */
    public objType get() {
        return this.iAbstrDoubleList.odeberPrvni();
    }

    /**
     * Ukládá datový kontejner
     * @param data datový kontejner
     */
    public void set(objType data) {
        this.iAbstrDoubleList.vlozPosledni(data);
    }

    /**
     * Je prohlídka prázdná? Neobsahuje žádné datové kontejnery?
     * @return true = je prázdná, false = obsahuje data
     */
    public boolean jePrazdny() {
        return this.iAbstrDoubleList.jePrazdny();
    }
}
