/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Aplikace.ProgOrganizacePodniku;

import Abstrakt.AbstrStrom.AbstrStrom;
import Abstrakt.AbstrStrom.IAbstrStrom;
import Aplikace.OrganizacePodniku.OrganizacePodniku;
import Aplikace.OrganizacePodniku.RadovyZamestnanec;
import Aplikace.OrganizacePodniku.VedouciZamestnanec;
import Aplikace.OrganizacePodniku.Zamestnanec;
import java.io.Serializable;

/**
 *
 * @author Administrator
 */
public class Menu implements Serializable {

    OrganizacePodniku<Object> organizacePodniku = new OrganizacePodniku<Object>();
    private int id, cislo_kancelare, pocet_primych_podrizenych;
    private String jmeno, prijmeni, pracovni_pozice;
    private char udalost;

    public Menu() {
    }

    private void vykresliCaru() {
        System.out.println("---------------------------------");
    }

    public void vypisMenu() {
        for (int i = 0; i < 20; i++) {
            System.out.println("\n");
        }
        vykresliCaru();
        System.out.println("\ts: Přidej kořen (Hlavní šéf)");
        System.out.println("Z klavesnice:");
        System.out.println("\t1. Pridej vedouciho zamestnance");
        System.out.println("\t2. Pridej radoveho zamestnance");
        System.out.println("Z generatoru:");
        System.out.println("\t3. Generuj vedouci zamestnance");
        System.out.println("\t4. Generuj radove zamestnance");
        System.out.println("Soubor:");
        System.out.println("\t5. Uloz do souboru");
        System.out.println("\t6. Nacti ze souboru");
        System.out.println("\t7. Uloz do text souboru");
        System.out.println("Dalsi operace:");
        System.out.println("\tv: Vypis dat");
        System.out.println("\tz: Zrus seznam");
        vykresliCaru();
        System.out.println("k: Konec");
        vykresliCaru();
        this.udalost = Nacitani.NactiRadekChar("Zadej pozadovany prikaz: ");
        pozadavekMenu(udalost);
    }

    private void pozadavekMenu(char udalost) {
        String nazevSouboru;

        switch (udalost) {
            case '1':
                kPridejVedouciho();
                break;
            case '2':
                kPridejRadoveho();
                break;
            case '3':
                gPridejVedouciho(Nacitani.NactiInt("Pocet generovanych hodnot: "));
                break;
            case '4':
                gPridejRadoveho(Nacitani.NactiInt("Pocet generovaných hodnot: "));
                break;
            case '5':
                nazevSouboru = Nacitani.NactiRadekStr("Nazev souboru (bez pripony): ");
                this.organizacePodniku.ulozDoSouboru(nazevSouboru + ".dta");
                break;
            case '6':
                this.organizacePodniku.zrus();
                nazevSouboru = Nacitani.NactiRadekStr("Nazev souboru (bez pripony): ");
                this.organizacePodniku.nactiZeSouboru(nazevSouboru + ".dta");
                break;
            case '7':
                nazevSouboru = Nacitani.NactiRadekStr("Nazev souboru (bez pripony): ");
                this.organizacePodniku.ulozDoTxtSouboru(nazevSouboru + ".txt");
                break;
            case 'v':
                vypisData();
                break;
            case 'z':
                zrusSeznam();
                break;
            case 'k':
                System.exit(0);
                break;
            case 's':
                pridejKoren();
            default:
                System.out.println("Neznamy pozadavek\n");
                break;
        }
    }

    private void kZakladniUdaje() {
        this.jmeno = Nacitani.NactiRadekStr(" Zadej jmeno: ");
        this.prijmeni = Nacitani.NactiRadekStr(" Zadej prijmeni: ");
        this.id = Nacitani.NactiInt(" Zadej ID: ");
        this.cislo_kancelare = Nacitani.NactiInt(" Zadej cislo kancelare: ");
    }

    private void kPridejVedouciho() {
        kZakladniUdaje();
        this.pocet_primych_podrizenych = Nacitani.NactiInt(" Pocer primych podrizenych: ");
        this.organizacePodniku.vloz(new VedouciZamestnanec(id, jmeno, prijmeni, cislo_kancelare, pocet_primych_podrizenych));
    }

    private void kPridejRadoveho() {
        kZakladniUdaje();
        this.pracovni_pozice = Nacitani.NactiRadekStr(" Pracovni pozice: ");
        this.organizacePodniku.vloz(new RadovyZamestnanec(id, jmeno, prijmeni, cislo_kancelare, pracovni_pozice));
    }

    private void gPridejVedouciho(int pocet) {
        Generator generator = new Generator();
        for (int i = 0; i < pocet; i++) {
            this.organizacePodniku.vloz(new VedouciZamestnanec(generator.cislo(),
                    generator.retezec(),
                    generator.retezec(),
                    generator.cislo(),
                    generator.cislo()));
        }
    }

    private void gPridejRadoveho(int pocet) {
        Generator generator = new Generator();
        for (int i = 0; i < pocet; i++) {
            this.organizacePodniku.vloz(new RadovyZamestnanec(generator.cislo(),
                    generator.retezec(),
                    generator.retezec(),
                    generator.cislo(),
                    generator.retezec()));
        }
    }

    private void vypisData() {
        this.organizacePodniku.vypis();
        Nacitani.NactiRadekStr("Pokracuj");
    }

    private void zrusSeznam() {
        this.organizacePodniku.zrus();
    }

    private void pridejKoren() {
        kZakladniUdaje();
        this.organizacePodniku.pridejKoren(new Zamestnanec(this.id, this.jmeno, this.prijmeni, this.cislo_kancelare));
    }
}
