/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package TrakalTest;

import Abstrakt.AbstrStrom.AbstrStrom;
import java.util.Iterator;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Administrator
 */
public class A_test {

    /**
     * Testovaci jednoducha trida
     */
    private class TestClass {

        public int a;

        private TestClass(int i) {
            a = i;
        }
    }

    @Test
    public void vlozKorenTest() {
        AbstrStrom<TestClass> abstrStrom = new AbstrStrom<TestClass>() {
        };
        TestClass t1 = new TestClass(1);

        assertEquals(true, abstrStrom.jePrazdny());
        abstrStrom.vlozKoren(t1);
        assertEquals(true, abstrStrom.jePrazdny());

        abstrStrom.vytvor();
        assertEquals(false, abstrStrom.jePrazdny());

        abstrStrom.vlozKoren(t1);
        assertEquals(t1, abstrStrom.zpristupniKoren());
        assertEquals(false, abstrStrom.jePrazdny());
    }

    @Test
    public void zrusTest() {
        AbstrStrom<TestClass> abstrStrom = new AbstrStrom<TestClass>() {
        };
        
        assertEquals(true, abstrStrom.jePrazdny());
        abstrStrom.zrus();

        abstrStrom.vytvor();
        assertEquals(false, abstrStrom.jePrazdny());

        TestClass t1 = new TestClass(1);
        abstrStrom.vlozKoren(t1);
        assertEquals(false, abstrStrom.jePrazdny());
        
        abstrStrom.zrus();
        assertEquals(true, abstrStrom.jePrazdny());
    }

    @Test
    public void vlozListTest() {
        AbstrStrom<TestClass> abstrStrom = new AbstrStrom<TestClass>() {
        };
        TestClass t1 = new TestClass(1);
        TestClass t2 = new TestClass(2);
        TestClass t11 = new TestClass(11);
        TestClass t12 = new TestClass(12);
        TestClass t21 = new TestClass(21);
        TestClass t22 = new TestClass(22);

        abstrStrom.vytvor();
        abstrStrom.vlozList(t1);
        abstrStrom.vlozList(t2);
        abstrStrom.zpristupniSyna(1);
        abstrStrom.vlozList(t11);
        abstrStrom.vlozList(t12);
        abstrStrom.zpristupniSyna(2);
        abstrStrom.vlozList(t21);
        abstrStrom.vlozList(t22);

    }
}
