/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Abstrakt.AbstrStrom;

/**
 * Prohlídka do šířky, nebo hloubky
 * @author Administrator
 */
public interface IProhlidka<objType> {

    /**
     * Vrací datový kontejner ukládaných dat
     * @return datový kontejner
     */
    objType get();

    /**
     * Je prohlídka prázdná? Neobsahuje žádné datové kontejnery?
     * @return true = je prázdná, false = obsahuje data
     */
    boolean jePrazdny();

    /**
     * Ukládá datový kontejner
     * @param data datový kontejner
     */
    void set(objType data);
}
