/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package Aplikace.OrganizacePodniku;

import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * Interface pro Soubor
 * @author Administrator
 */
public interface ISoubor {

    /**
     * Načtení dat ze souboru
     * @param soubor název souboru s daty
     * @return Datová struktura, kterou obsahuje soubor, následně se musí přetypovat
     * @throws IOException
     * @throws ClassNotFoundException
     */
    Object nacti(String soubor) throws IOException, ClassNotFoundException;

    /**
     * Uložení objektu do souboru
     * @param soubor název souboru
     * @param object datová struktura ukládaná do souboru
     * @throws FileNotFoundException pokud není nalezen/vytvořen soubor
     * @throws IOException chyba při ukládání struktury (např. nedošlo k serializaci dat)
     */
    void uloz(String soubor, Object object) throws FileNotFoundException, IOException;

}
