/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package Aplikace.OrganizacePodniku;

import Abstrakt.AbstrStrom.IAbstrStrom;
import Abstrakt.AbstrStrom.TypProhlidky;
import Abstrakt.IIterator;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

/**
 *
 * @author Administrator
 */
public class SouborTxt implements ISouborTxt {

    private PrintWriter outputStream = null;

    public SouborTxt() {
    }

    public void uloz(String soubor, boolean pridavat, IAbstrStrom data) throws FileNotFoundException, IOException {
        try {
            outputStream = new PrintWriter(new FileWriter(soubor, pridavat), pridavat);
            IIterator<Object> iIterator = data.vytvorIterator(TypProhlidky.DO_SIRKY);
            while (iIterator.hasNext()) {
                outputStream.println(iIterator.next());
            }
        } finally {
            if (outputStream != null) {
                outputStream.close();
            }
        }
    }
}
